#!/usr/bin/php

<?php
// Read ini file
$ini=parse_ini_file(dirname(__FILE__).DIRECTORY_SEPARATOR."watcher.ini");
if (!isset($ini['ALLOW'])) { echo "No ALLOW entries, exit\n"; return; }
if (!is_array($ini['ALLOW'])) { $s=$ini['ALLOW']; unset($ini['ALLOW']); $ini['ALLOW'][0]=$s; }
if (!isset($ini['DENY'])) { $ini['DENY'][0]="?"; }
else {
	if (!is_array($ini['DENY'])) { $s=$ini['DENY']; unset($ini['DENY']); $ini['DENY'][0]=$s; }
}
if (!isset($ini['DENY_FILE'])) { $ini['DENY_FILE'][0]="?"; }
else {
	if (!is_array($ini['DENY_FILE'])) { $s=$ini['DENY_FILE']; unset($ini['DENY_FILE']); $ini['DENY_FILE'][0]=$s; }
}
if (!isset($ini['DENY_EXT'])) { $ini['DENY_EXT'][0]="?"; }
else {
	if (!is_array($ini['DENY_EXT'])) { $s=$ini['DENY_EXT']; unset($ini['DENY_EXT']); $ini['DENY_EXT'][0]=$s; }
}
// Where will be log file
if (isset($ini['LOG'])) $PATH=$ini['LOG'].DIRECTORY_SEPARATOR; else $PATH=dirname(__FILE__).DIRECTORY_SEPARATOR;
// Circle for all allowed dirs
$I=0;
foreach ($ini['ALLOW'] as $allow) {
	$res=getFileList($allow,$ini['DENY'],$ini['DENY_FILE'],$ini['DENY_EXT']);
	if ($res) {
		$c=count($res);
		for ($i=0;$i<$c;$i++) $result[$I++]=$res[$i];
	}
}
// Sort record
sort($result);
// Compare records
$message="";
if (file_exists($PATH."filelist.log")) {
	$OLD=file($PATH."filelist.log",FILE_IGNORE_NEW_LINES);
	$n=count($OLD);
	$j=0; 
	if ($n>0) $old=$OLD[0]; else $old="";
	// Compare old and new records
	foreach ($result as $r) {
		$a=explode("\t",$r);
		$b=explode("\t",$old);
		while (($f=strcmp($a[0],$b[0]))>0) { // At the current list no old files
			if (count($b)==3) $message.="File deleted: ".$b[0]." length=".$b[1]."\n";
			else $message.="Directory deleted: ".$b[0]."\n";
			// Get next old record
			$j++;
			if ($j<$n) { $old=$OLD[$j]; $b=explode("\t",$old); }
			else { break; }
		}
		if ($f>0);
		else {
			if ($f==0) { // Files or directories equals
				if ($r!=$old) $message.="File size changed: ".$b[0]." from ".$b[1]." to ".$a[1]."\n"; // But different size
				$j++; if ($j<$n) $old=$OLD[$j]; else $old=""; // Get next old record
			}
			else { // New file or directory appear
				if (count($a)==3) $message.="New file: ".$a[0]." length=".$a[1]."\n";
				else $message.="New directory: ".$a[0]."\n";
			}
		}
	}
}
// Write files list
$fd=fopen($PATH."filelist.log","w");
foreach ($result as $r) fwrite($fd,$r."\n");
fclose($fd);
// Check new date
$label="[".date("Y-m-d H:i:s")."]";
$new_date=false;
if (file_exists($PATH."today.log")) {
	$fd=fopen($PATH."today.log","r");
	$s=fgets($fd,12);
	fclose($fd);
	if ($s!=substr($label,0,11)) $new_date=true;
}
// Send E-mail message
if ((isset($ini['EMAIL']))&&($message!="")) {
	if (!is_array($ini['EMAIL'])) { $s=$ini['EMAIL']; unset($ini['EMAIL']); $ini['EMAIL'][0]=$s; }
	$subject="File Watcher at ".$ini['HOSTNAME'].". Spy results at ".$label;
	$msg=str_replace("\\","\\\\",$message);
	$msg=str_replace("\n","<br>\n",$msg);
	foreach ($ini['EMAIL'] as $email) {
		socketmail($email,$ini['SMTP_USER']."@".$ini['SMTP_DOMAIN'],$subject,$msg,$ini['SMTP_HOST'],$ini['SMTP_DOMAIN'],$ini['SMTP_USER'],$ini['SMTP_PASSWORD']);
	}
}
// Send daily report
if ((isset($ini['EMAIL']))&&($new_date)) {
	if (!is_array($ini['EMAIL'])) { $s=$ini['EMAIL']; unset($ini['EMAIL']); $ini['EMAIL'][0]=$s; }
	$subject="File Watcher at ".$ini['HOSTNAME']." daily report ".substr($label,0,11)."]";
	$msg=str_replace("\\","\\\\",file_get_contents($PATH."today.log"));
	$msg=str_replace("\n","<br>\n",$msg);
	foreach ($ini['EMAIL'] as $email) {
		socketmail($email,$ini['SMTP_USER']."@".$ini['SMTP_DOMAIN'],$subject,$msg,$ini['SMTP_HOST'],$ini['SMTP_DOMAIN'],$ini['SMTP_USER'],$ini['SMTP_PASSWORD']);
	}
	
}
if ($new_date) { // New day
	// Delete yesterday report
	if (file_exists($PATH."yesterday.log")) unlink($PATH."yesterday.log");
	// Rename current report
	if (file_exists($PATH."today.log")) rename($PATH."today.log",$PATH."yesterday.log");
	// Write to new report
	$fd=fopen($PATH."today.log","w");
	fwrite($fd,$label."\n".$message);
	fclose($fd);
}
// Write changes file
$fd=fopen($PATH."changes.log","a");
fwrite($fd,$label."\n".$message);
fclose($fd);
// Write today log
$fd=fopen($PATH."today.log","a");
fwrite($fd,$label."\n".$message);
fclose($fd);
// Write web log file
if (isset($ini['WEBLOG'])) {
	web_page($ini['WEBLOG'],$message);
}


//------------------------------------------------------------------------------------------
function checkDir($dirname,$deny) {
foreach ($deny as $d) if ($dirname==$d) return(false);
return(true);
}
//------------------------------------------------------------------------------------------
function getFileList($dirname,$deny,$deny_file,$deny_ext) {
$n=0; // No files counted
if (is_dir($dirname)) {
    if ($dh=opendir($dirname)) {
		// Circle for all files in the directory
        while (($file=readdir($dh))!== false) {
			if ($file != "." && $file != "..") {  
				$fname=$dirname.DIRECTORY_SEPARATOR.$file;
	            if (is_file($fname)) { // This is file
					$flag=true;
					$ext=pathinfo($file,PATHINFO_EXTENSION);
					foreach ($deny_ext as $d) { // Check file extension
						if ($d==$ext) { $flag=false; break; }
					}
					if ($flag) {
						foreach ($deny_file as $d) { // Check file name
							if ($d==$file) { $flag=false; break; }
						}
					}
					if ($flag) {
						$result[$n]=$fname."\t".filesize($fname)."\t".filemtime($fname);
						$n++;
					}
				}
	            else if (is_dir($fname)) { // This is directory
					$result[$n++]=$fname; // Add dirname to list
					if (checkDir($fname,$deny)) {
						$res=getFileList($fname,$deny,$deny_file,$deny_ext);
						if ($res) { 
							$c=count($res);
							for ($i=0;$i<$c;$i++) $result[$n++]=$res[$i];
						}
					}
				}
		    }
        }
        closedir($dh);
    }
}
if ($n==0) return(false);
return($result);
}
//------------------------------------------------------------------------------------------
function web_page($dir,$message) {
GLOBAL $PATH,$ini;
$dir1=$PATH;
$dir2=$dir.DIRECTORY_SEPARATOR;
$navigation="<div align='center'>\n"
	."<button type='button' onclick='document.location.href=\"index.html\"' style='width:240px;height:40px;'>Current state</button> &nbsp; \n"
	."<button type='button' onclick='document.location.href=\"today.html\"' style='width:240px;height:40px;'>Today log</button> &nbsp; \n"
	."<button type='button' onclick='document.location.href=\"yesterday.html\"' style='width:240px;height:40px;'>Yesterday log</button>\n"
	."</div>\n";
// index.html
$fd=fopen($dir2."index.html","w");
if ($message=="") {
	$html="<!DOCTYPE html>\n<html>\n<head>\n<meta charset='utf-8'>\n<title>File Watcher</title>\n</head>\n<body>\n"
		.$navigation
		."<h1>File Watcher at ".$ini['HOSTNAME']."</h1>\n<h2>Files checked (".date("Y-m-d H:i:s").")</h2>\n<h3>No changes<h3>\n</body>\n"
		."<script>setTimeout(function(){location.reload();},".$ini['PAGE_REFRESH']."000);</script>"
		."</html>\n";
}
else  {
	$html="<!DOCTYPE html>\n<html>\n<head>\n<meta charset='utf-8'>\n<title>File Watcher</title>\n</head>\n<body bgcolor='#FF0000' text='FFFFFF'>\n"
		.$navigation
		."<audio autoplay><source src='alarm.ogg' type='audio/ogg'><source src='alarm.mp3' type='audio/mpeg'></audio>\n"
		."<h1>File Watcher at ".$ini['HOSTNAME']."</h1>\n<h2>Files was changed (".date("Y-m-d H:i:s").")</h2><pre>".$message."</pre>\n</body>\n"
		."<script>setTimeout(function(){location.reload();},".$ini['PAGE_REFRESH']."000);</script>"
		."</html>\n";
	$s=$dir1."audio".DIRECTORY_SEPARATOR."alarm.ogg"; $ss=$dir2."alarm.ogg"; if (file_exists($s)) copy($s,$ss);
	$s=$dir1."audio".DIRECTORY_SEPARATOR."alarm.mp3"; $ss=$dir2."alarm.mp3"; if (file_exists($s)) copy($s,$ss);
}
fwrite($fd,$html);
fclose($fd);
// yesterday.html
$fd=fopen($dir2."yesterday.html","w");
$html="<!DOCTYPE html>\n<html>\n<head>\n<meta charset='utf-8'>\n<title>File Watcher</title>\n</head>\n<body>\n"
	.$navigation
	."<h1>File Watcher at ".$ini['HOSTNAME']."</h1>\n<h2>Yesterday log<h3>\n</body>\n"
	."<pre>\n";
if (file_exists($dir1."yesterday.log")) $html.=file_get_contents($dir1."yesterday.log");
$html.="</pre>\n</html>\n";
fwrite($fd,$html);
fclose($fd);
// today.html
$fd=fopen($dir2."today.html","w");
$html="<!DOCTYPE html>\n<html>\n<head>\n<meta charset='utf-8'>\n<title>File Watcher</title>\n</head>\n<body>\n"
	.$navigation
	."<h1>File Watcher at ".$ini['HOSTNAME']."</h1>\n<h2>Today log<h3>\n</body>\n"
	."<pre>\n";
if (file_exists($dir1."today.log")) $html.=file_get_contents($dir1."today.log");
$html.="</pre>\n</html>\n";
fwrite($fd,$html);
fclose($fd);
}
//------------------------------------------------------------------------------------------
function socketmail($to,$from,$subject,$message,$host,$domain,$user,$password) { 
	$connect = fsockopen ($host, 25, $errno, $errstr, 30); 
	if (!$connect) { echo "Can't open socket!";	return; }
	// Аутентификация
	fputs($connect, "HELO ".$domain."\r\n"); 
	$data = get_data($connect);
    fputs($connect, "AUTH LOGIN\n"); 
	$data = get_data($connect);
    fputs($connect, base64_encode($user)."\n"); 
	$data = get_data($connect);
    fputs($connect, base64_encode($password)."\n"); 
	$data = get_data($connect);
    fputs($connect, "MAIL FROM: ".$from."\n");
	$data = get_data($connect);
    fputs($connect, "RCPT TO: ".$to."\n"); 
	$data = get_data($connect);
    fputs($connect, "DATA\n"); 
	$data = get_data($connect);
    fputs($connect, "Content-type: text/html; charset=utf-8\n"); 
    fputs($connect, "To: ".$to."\n"); 
    fputs($connect, "From: ".$from."\n"); 
    fputs($connect, "Subject: ".$subject."\n"); 
    fputs($connect, "\n\n"); 
	$data = get_data($connect);
    fputs($connect, stripslashes($message)." \n"); 
    fputs($connect, ".\n"); 
	$data = get_data($connect);
    fputs($connect, "QUIT\n"); 
	$data = get_data($connect);
	fclose($connect);
} 
//------------------------------------------------------------------------------------------
function get_data($smtp_conn) {
$data="";
while($str = fgets($smtp_conn,515)) { $data .= $str; if(substr($str,3,1) == " ") break; }
return $data;
}
//------------------------------------------------------------------------------------------
?>